com.fasterxml.jackson.databind.introspect

## Class AnnotationIntrospectorPair

- java.lang.Object
- - com.fasterxml.jackson.databind.AnnotationIntrospector
  - - com.fasterxml.jackson.databind.introspect.AnnotationIntrospectorPair

All Implemented Interfaces:
  Versioned, Serializable

    public class AnnotationIntrospectorPair
    extends AnnotationIntrospector
    implements Serializable

Helper class that allows using 2 introspectors such that one introspector acts as the primary one to use; and second one as a fallback used if the primary does not provide conclusive or useful result for a method.

An obvious consequence of priority is that it is easy to construct longer chains of introspectors by linking multiple pairs. Currently most likely combination is that of using the default Jackson provider, along with JAXB annotation introspector.

Note: up until 2.0, this class was an inner class of `AnnotationIntrospector`; moved here for convenience.

Since:
  2.1
See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.AnnotationIntrospector

`AnnotationIntrospector.ReferenceProperty`

### Field Summary

Fields
`protected AnnotationIntrospector` `_primary`
`protected AnnotationIntrospector` `_secondary`

### Constructor Summary

Constructors
Constructor and Description
`AnnotationIntrospectorPair(AnnotationIntrospector p, AnnotationIntrospector s)`

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
`protected Object` `_explicitClassOrOb(Object maybeCls, Class<?> implicit)`
`protected boolean` `_isExplicitClassOrOb(Object maybeCls, Class<?> implicit)`
`Collection<AnnotationIntrospector>` `allIntrospectors()` Method that can be used to collect all "real" introspectors that this introspector contains, if any; or this introspector if it is not a container.
`Collection<AnnotationIntrospector>` `allIntrospectors(Collection<AnnotationIntrospector> result)` Method that can be used to collect all "real" introspectors that this introspector contains, if any; or this introspector if it is not a container.
`static AnnotationIntrospector` `create(AnnotationIntrospector primary, AnnotationIntrospector secondary)` Helper method for constructing a Pair from two given introspectors (if neither is null); or returning non-null introspector if one is null (and return just null if both are null)
`void` `findAndAddVirtualProperties(MapperConfig<?> config, AnnotatedClass ac, List<BeanPropertyWriter> properties)` Method for adding possible virtual properties to be serialized along with regular properties.
`VisibilityChecker<?>` `findAutoDetectVisibility(AnnotatedClass ac, VisibilityChecker<?> checker)` Method for checking if annotations indicate changes to minimum visibility levels needed for auto-detecting property elements (fields, methods, constructors).
`String` `findClassDescription(AnnotatedClass ac)` Method used to check whether specified class defines a human-readable description to use for documentation.
`Object` `findContentDeserializer(Annotated am)` Method for getting a deserializer definition for content (values) of associated `Collection`, `array` or `Map` property.
`Object` `findContentSerializer(Annotated a)` Method for getting a serializer definition for content (values) of associated `Collection`, `array` or `Map` property.
`JsonCreator.Mode` `findCreatorAnnotation(MapperConfig<?> config, Annotated a)` Method called to check whether potential Creator (constructor or static factory method) has explicit annotation to indicate it as actual Creator; and if so, which `JsonCreator.Mode` to use.
`JsonCreator.Mode` `findCreatorBinding(Annotated a)` Deprecated.
`Enum<?>` `findDefaultEnumValue(Class<Enum<?>> enumCls)` Finds the Enum value that should be considered the default value, if possible.
`Object` `findDeserializationContentConverter(AnnotatedMember a)` Method for finding `Converter` that annotated property has indicated needs to be used for values of container type (this also means that method should only be called for properties of container types, List/Map/array properties).
`Class<?>` `findDeserializationContentType(Annotated am, JavaType baseContentType)` Deprecated.
`Object` `findDeserializationConverter(Annotated a)` Method for finding `Converter` that annotated entity (property or class) has indicated to be used as part of deserialization.
`Class<?>` `findDeserializationKeyType(Annotated am, JavaType baseKeyType)` Deprecated.
`Class<?>` `findDeserializationType(Annotated am, JavaType baseType)` Deprecated.
`Object` `findDeserializer(Annotated a)` Method for getting a deserializer definition on specified method or field.
`String` `findEnumValue(Enum<?> value)` Deprecated.
`String[]` `findEnumValues(Class<?> enumType, Enum<?>[] enumValues, String[] names)` Method for efficiently figuring out which if given set of `Enum` values have explicitly defined name.
`Object` `findFilterId(Annotated ann)` Method for finding if annotated class has associated filter; and if so, to return id that is used to locate filter.
`JsonFormat.Value` `findFormat(Annotated ann)` Method for finding format annotations for property or class.
`Boolean` `findIgnoreUnknownProperties(AnnotatedClass ac)` Deprecated.
`String` `findImplicitPropertyName(AnnotatedMember ann)` Method for finding implicit name for a property that given annotated member (field, method, creator parameter) may represent.
`JacksonInject.Value` `findInjectableValue(AnnotatedMember m)` Method called to find out whether given member expectes a value to be injected, and if so, what is the identifier of the value to use during injection.
`Object` `findInjectableValueId(AnnotatedMember m)` Deprecated.
`Object` `findKeyDeserializer(Annotated a)` Method for getting a deserializer definition for keys of associated `Map` property.
`Object` `findKeySerializer(Annotated a)` Method for getting a serializer definition for keys of associated `Map` property.
`Boolean` `findMergeInfo(Annotated a)` Method for finding merge settings for property, if any.
`PropertyName` `findNameForDeserialization(Annotated a)` Method for checking whether given property accessors (method, field) has an annotation that suggests property name to use for deserialization (reading JSON into POJOs).
`PropertyName` `findNameForSerialization(Annotated a)` Method for checking whether given property accessors (method, field) has an annotation that suggests property name to use for serialization.
`Object` `findNamingStrategy(AnnotatedClass ac)` Method for finding `PropertyNamingStrategy` for given class, if any specified by annotations; and if so, either return a `PropertyNamingStrategy` instance, or Class to use for creating instance
`Object` `findNullSerializer(Annotated a)` Method for getting a serializer definition for serializer to use for nulls (null values) of associated property or type.
`ObjectIdInfo` `findObjectIdInfo(Annotated ann)` Method for checking whether given annotated thing (type, or accessor) indicates that values referenced (values of type of annotated class, or values referenced by annotated property; latter having precedence) should include Object Identifier, and if so, specify details of Object Identity used.
`ObjectIdInfo` `findObjectReferenceInfo(Annotated ann, ObjectIdInfo objectIdInfo)` Method for figuring out additional properties of an Object Identity reference
`Class<?>` `findPOJOBuilder(AnnotatedClass ac)` Method for finding Builder object to use for constructing value instance and binding data (sort of combining value instantiators that can construct, and deserializers that can bind data).
`JsonPOJOBuilder.Value` `findPOJOBuilderConfig(AnnotatedClass ac)`
`String[]` `findPropertiesToIgnore(Annotated ac)` Deprecated.
`String[]` `findPropertiesToIgnore(Annotated ac, boolean forSerialization)` Deprecated.
`JsonProperty.Access` `findPropertyAccess(Annotated ann)` Method for finding optional access definition for a property, annotated on one of its accessors.
`List<PropertyName>` `findPropertyAliases(Annotated ann)` Method called to find if given property has alias(es) defined.
`TypeResolverBuilder<?>` `findPropertyContentTypeResolver(MapperConfig<?> config, AnnotatedMember am, JavaType baseType)` Method for checking if given structured property entity (field or method that has nominal value of Map, Collection or array type) has annotations that indicate that specific type resolver is to be used for handling type information of contained values.
`String` `findPropertyDefaultValue(Annotated ann)` Method for finding suggested default value (as simple textual serialization) for the property.
`String` `findPropertyDescription(Annotated ann)` Method used to check whether specified property member (accessor or mutator) defines human-readable description to use for documentation.
`JsonIgnoreProperties.Value` `findPropertyIgnorals(Annotated a)` Method for finding information about properties to ignore either by name, or by more general specification ("ignore all unknown").
`JsonInclude.Value` `findPropertyInclusion(Annotated a)` Method for checking inclusion criteria for a type (Class) or property (yes, method name is bit unfortunate -- not just for properties!).
`Integer` `findPropertyIndex(Annotated ann)` Method used to check whether specified property member (accessor or mutator) defines numeric index, and if so, what is the index value.
`TypeResolverBuilder<?>` `findPropertyTypeResolver(MapperConfig<?> config, AnnotatedMember am, JavaType baseType)` Method for checking if given property entity (field or method) has annotations that indicate that specific type resolver is to be used for handling instances.
`AnnotationIntrospector.ReferenceProperty` `findReferenceType(AnnotatedMember member)` Method for checking if given member indicates that it is part of a reference (parent/child).
`PropertyName` `findRootName(AnnotatedClass ac)` Method for locating name used as "root name" (for use by some serializers when outputting root-level object -- mostly for XML compatibility purposes) for given class, if one is defined.
`Object` `findSerializationContentConverter(AnnotatedMember a)` Method for finding `Converter` that annotated property has indicated needs to be used for values of container type (this also means that method should only be called for properties of container types, List/Map/array properties).
`Class<?>` `findSerializationContentType(Annotated am, JavaType baseType)` Deprecated.
`Object` `findSerializationConverter(Annotated a)` Method for finding `Converter` that annotated entity (property or class) has indicated to be used as part of serialization.
`JsonInclude.Include` `findSerializationInclusion(Annotated a, JsonInclude.Include defValue)` Deprecated.
`JsonInclude.Include` `findSerializationInclusionForContent(Annotated a, JsonInclude.Include defValue)` Deprecated.
`Class<?>` `findSerializationKeyType(Annotated am, JavaType baseType)` Deprecated.
`String[]` `findSerializationPropertyOrder(AnnotatedClass ac)` Method for accessing defined property serialization order (which may be partial).
`Boolean` `findSerializationSortAlphabetically(Annotated ann)` Method for checking whether an annotation indicates that serialized properties for which no explicit is defined should be alphabetically (lexicograpically) ordered
`Class<?>` `findSerializationType(Annotated a)` Deprecated.
`JsonSerialize.Typing` `findSerializationTyping(Annotated a)` Method for accessing declared typing mode annotated (if any).
`Object` `findSerializer(Annotated am)` Method for getting a serializer definition on specified method or field.
`JsonSetter.Value` `findSetterInfo(Annotated a)` Method for finding possible settings for property, given annotations on an accessor.
`List<NamedType>` `findSubtypes(Annotated a)` Method for locating annotation-specified subtypes related to annotated entity (class, method, field).
`String` `findTypeName(AnnotatedClass ac)` Method for checking if specified type has explicit name.
`TypeResolverBuilder<?>` `findTypeResolver(MapperConfig<?> config, AnnotatedClass ac, JavaType baseType)` Method for checking if given class has annotations that indicate that specific type resolver is to be used for handling instances.
`NameTransformer` `findUnwrappingNameTransformer(AnnotatedMember member)` Method called to check whether given property is marked to be "unwrapped" when being serialized (and appropriately handled in reverse direction, i.e.
`Object` `findValueInstantiator(AnnotatedClass ac)` Method getting `ValueInstantiator` to use for given type (class): return value can either be an instance of instantiator, or class of instantiator to create.
`Class<?>[]` `findViews(Annotated a)` Method for checking if annotated property (represented by a field or getter/setter method) has definitions for views it is to be included in.
`PropertyName` `findWrapperName(Annotated ann)` Method used to check if specified property has annotation that indicates that it should be wrapped in an element; and if so, name to use.
`Boolean` `hasAnyGetter(Annotated a)` Method for checking whether given method has an annotation that suggests that the method is to serve as "any setter"; method to be used for accessing set of miscellaneous "extra" properties, often bound with matching "any setter" method.
`boolean` `hasAnyGetterAnnotation(AnnotatedMethod am)` Deprecated.
`Boolean` `hasAnySetter(Annotated a)` Method for checking whether given method has an annotation that suggests that the method is to serve as "any setter"; method to be used for setting values of any properties for which no dedicated setter method is found.
`boolean` `hasAnySetterAnnotation(AnnotatedMethod am)` Deprecated.
`Boolean` `hasAsValue(Annotated a)` Method for checking whether given method has an annotation that suggests that the return value of annotated method should be used as "the value" of the object instance; usually serialized as a primitive value such as String or number.
`boolean` `hasAsValueAnnotation(AnnotatedMethod am)` Deprecated.
`boolean` `hasCreatorAnnotation(Annotated a)` Deprecated.
`boolean` `hasIgnoreMarker(AnnotatedMember m)` Method called to check whether given property is marked to be ignored.
`Boolean` `hasRequiredMarker(AnnotatedMember m)` Method that can be called to check whether this member has an annotation that suggests whether value for matching property is required or not.
`boolean` `isAnnotationBundle(Annotation ann)` Method for checking whether given annotation is considered an annotation bundle: if so, all meta-annotations it has will be used instead of annotation ("bundle") itself.
`Boolean` `isIgnorableType(AnnotatedClass ac)` Method for checking whether properties that have specified type (class, not generics aware) should be completely ignored for serialization and deserialization purposes.
`Boolean` `isTypeId(AnnotatedMember member)` Method for checking whether given accessor claims to represent type id: if so, its value may be used as an override, instead of generated type id.
`JavaType` `refineDeserializationType(MapperConfig<?> config, Annotated a, JavaType baseType)` Method called to find out possible type refinements to use for deserialization.
`JavaType` `refineSerializationType(MapperConfig<?> config, Annotated a, JavaType baseType)` Method called to find out possible type refinements to use for deserialization, including not just value itself but key and/or content type, if type has those.
`AnnotatedMethod` `resolveSetterConflict(MapperConfig<?> config, AnnotatedMethod setter1, AnnotatedMethod setter2)` Method called in cases where a class has two methods eligible to be used for the same logical property, and default logic is not enough to figure out clear precedence.
`Version` `version()`

### Methods inherited from class com.fasterxml.jackson.databind.AnnotationIntrospector

`_findAnnotation, _hasAnnotation, _hasOneOf, nopInstance, pair`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### _primary

    protected final AnnotationIntrospector _primary

#### _secondary

    protected final AnnotationIntrospector _secondary

### Constructor Detail

#### AnnotationIntrospectorPair

    public AnnotationIntrospectorPair(AnnotationIntrospector p,
                                      AnnotationIntrospector s)

### Method Detail

#### version

    public Version version()

Specified by:
  `version` in interface `Versioned`
Specified by:
  `version` in class `AnnotationIntrospector`

#### create

    public static AnnotationIntrospector create(AnnotationIntrospector primary,
                                                AnnotationIntrospector secondary)

Helper method for constructing a Pair from two given introspectors (if neither is null); or returning non-null introspector if one is null (and return just null if both are null)

#### allIntrospectors

    public Collection<AnnotationIntrospector> allIntrospectors()

Description copied from class: `AnnotationIntrospector`
Method that can be used to collect all "real" introspectors that this introspector contains, if any; or this introspector if it is not a container. Used to get access to all container introspectors in their priority order.

Default implementation returns a Singleton list with this introspector as contents. This usually works for sub-classes, except for proxy or delegating "container introspectors" which need to override implementation.

Overrides:
  `allIntrospectors` in class `AnnotationIntrospector`

#### allIntrospectors

    public Collection<AnnotationIntrospector> allIntrospectors(Collection<AnnotationIntrospector> result)

Description copied from class: `AnnotationIntrospector`
Method that can be used to collect all "real" introspectors that this introspector contains, if any; or this introspector if it is not a container. Used to get access to all container introspectors in their priority order.

Default implementation adds this introspector in result; this usually works for sub-classes, except for proxy or delegating "container introspectors" which need to override implementation.

Overrides:
  `allIntrospectors` in class `AnnotationIntrospector`

#### isAnnotationBundle

    public boolean isAnnotationBundle(Annotation ann)

Description copied from class: `AnnotationIntrospector`
Method for checking whether given annotation is considered an annotation bundle: if so, all meta-annotations it has will be used instead of annotation ("bundle") itself.

Overrides:
  `isAnnotationBundle` in class `AnnotationIntrospector`

#### findRootName

    public PropertyName findRootName(AnnotatedClass ac)

Description copied from class: `AnnotationIntrospector`
Method for locating name used as "root name" (for use by some serializers when outputting root-level object -- mostly for XML compatibility purposes) for given class, if one is defined. Returns null if no declaration found; can return explicit empty String, which is usually ignored as well as null.

NOTE: method signature changed in 2.1, to return `PropertyName` instead of String.

Overrides:
  `findRootName` in class `AnnotationIntrospector`

#### findPropertyIgnorals

    public JsonIgnoreProperties.Value findPropertyIgnorals(Annotated a)

Description copied from class: `AnnotationIntrospector`
Method for finding information about properties to ignore either by name, or by more general specification ("ignore all unknown"). This method combines multiple aspects of ignorals and deprecates earlier methods such as `AnnotationIntrospector.findPropertiesToIgnore(Annotated, boolean)` and `AnnotationIntrospector.findIgnoreUnknownProperties(AnnotatedClass)`.

Overrides:
  `findPropertyIgnorals` in class `AnnotationIntrospector`

#### isIgnorableType

    public Boolean isIgnorableType(AnnotatedClass ac)

Description copied from class: `AnnotationIntrospector`
Method for checking whether properties that have specified type (class, not generics aware) should be completely ignored for serialization and deserialization purposes.

Overrides:
  `isIgnorableType` in class `AnnotationIntrospector`
Parameters:
  `ac` - Type to check
Returns:
  Boolean.TRUE if properties of type should be ignored; Boolean.FALSE if they are not to be ignored, null for default handling (which is 'do not ignore')

#### findFilterId

    public Object findFilterId(Annotated ann)

Description copied from class: `AnnotationIntrospector`
Method for finding if annotated class has associated filter; and if so, to return id that is used to locate filter.

Overrides:
  `findFilterId` in class `AnnotationIntrospector`
Returns:
  Id of the filter to use for filtering properties of annotated class, if any; or null if none found.

#### findNamingStrategy

    public Object findNamingStrategy(AnnotatedClass ac)

Description copied from class: `AnnotationIntrospector`
Method for finding `PropertyNamingStrategy` for given class, if any specified by annotations; and if so, either return a `PropertyNamingStrategy` instance, or Class to use for creating instance

Overrides:
  `findNamingStrategy` in class `AnnotationIntrospector`
Returns:
  Sub-class or instance of `PropertyNamingStrategy`, if one is specified for given class; null if not.

#### findClassDescription

    public String findClassDescription(AnnotatedClass ac)

Description copied from class: `AnnotationIntrospector`
Method used to check whether specified class defines a human-readable description to use for documentation. There are no further definitions for contents; for example, whether these may be marked up using HTML (or something like wiki format like Markup) is not defined.

Overrides:
  `findClassDescription` in class `AnnotationIntrospector`
Returns:
  Human-readable description, if any.

#### findPropertiesToIgnore

    @Deprecated
    public String[] findPropertiesToIgnore(Annotated ac)

Deprecated.

Overrides:
  `findPropertiesToIgnore` in class `AnnotationIntrospector`

#### findPropertiesToIgnore

    @Deprecated
    public String[] findPropertiesToIgnore(Annotated ac,
                                                       boolean forSerialization)

Deprecated.

Overrides:
  `findPropertiesToIgnore` in class `AnnotationIntrospector`
  `forSerialization` - True if requesting properties to ignore for serialization; false if for deserialization

#### findIgnoreUnknownProperties

    @Deprecated
    public Boolean findIgnoreUnknownProperties(AnnotatedClass ac)

Deprecated.
Description copied from class: `AnnotationIntrospector`
Method for checking whether an annotation indicates that all unknown properties

Overrides:
  `findIgnoreUnknownProperties` in class `AnnotationIntrospector`

#### findAutoDetectVisibility

    public VisibilityChecker<?> findAutoDetectVisibility(AnnotatedClass ac,
                                                         VisibilityChecker<?> checker)

Description copied from class: `AnnotationIntrospector`
Method for checking if annotations indicate changes to minimum visibility levels needed for auto-detecting property elements (fields, methods, constructors). A baseline checker is given, and introspector is to either return it as is (if no annotations are found), or build and return a derived instance (using checker's build methods).

Overrides:
  `findAutoDetectVisibility` in class `AnnotationIntrospector`

#### findTypeResolver

    public TypeResolverBuilder<?> findTypeResolver(MapperConfig<?> config,
                                                   AnnotatedClass ac,
                                                   JavaType baseType)

Description copied from class: `AnnotationIntrospector`
Method for checking if given class has annotations that indicate that specific type resolver is to be used for handling instances. This includes not only instantiating resolver builder, but also configuring it based on relevant annotations (not including ones checked with a call to `AnnotationIntrospector.findSubtypes(com.fasterxml.jackson.databind.introspect.Annotated)`

Overrides:
  `findTypeResolver` in class `AnnotationIntrospector`
Parameters:
  `config` - Configuration settings in effect (for serialization or deserialization)
  `ac` - Annotated class to check for annotations
  `baseType` - Base java type of value for which resolver is to be found
Returns:
  Type resolver builder for given type, if one found; null if none

#### findPropertyTypeResolver

    public TypeResolverBuilder<?> findPropertyTypeResolver(MapperConfig<?> config,
                                                           AnnotatedMember am,
                                                           JavaType baseType)

Description copied from class: `AnnotationIntrospector`
Method for checking if given property entity (field or method) has annotations that indicate that specific type resolver is to be used for handling instances. This includes not only instantiating resolver builder, but also configuring it based on relevant annotations (not including ones checked with a call to `AnnotationIntrospector.findSubtypes(com.fasterxml.jackson.databind.introspect.Annotated)`

Overrides:
  `findPropertyTypeResolver` in class `AnnotationIntrospector`
Parameters:
  `config` - Configuration settings in effect (for serialization or deserialization)
  `am` - Annotated member (field or method) to check for annotations
  `baseType` - Base java type of property for which resolver is to be found
Returns:
  Type resolver builder for properties of given entity, if one found; null if none

#### findPropertyContentTypeResolver

    public TypeResolverBuilder<?> findPropertyContentTypeResolver(MapperConfig<?> config,
                                                                  AnnotatedMember am,
                                                                  JavaType baseType)

Description copied from class: `AnnotationIntrospector`
Method for checking if given structured property entity (field or method that has nominal value of Map, Collection or array type) has annotations that indicate that specific type resolver is to be used for handling type information of contained values. This includes not only instantiating resolver builder, but also configuring it based on relevant annotations (not including ones checked with a call to `AnnotationIntrospector.findSubtypes(com.fasterxml.jackson.databind.introspect.Annotated)`

Overrides:
  `findPropertyContentTypeResolver` in class `AnnotationIntrospector`
Parameters:
  `config` - Configuration settings in effect (for serialization or deserialization)
  `am` - Annotated member (field or method) to check for annotations
  `baseType` - Type of property for which resolver is to be found (must be a container type)
Returns:
  Type resolver builder for values contained in properties of given entity, if one found; null if none

#### findSubtypes

    public List<NamedType> findSubtypes(Annotated a)

Description copied from class: `AnnotationIntrospector`
Method for locating annotation-specified subtypes related to annotated entity (class, method, field). Note that this is only guaranteed to be a list of directly declared subtypes, no recursive processing is guarantees (i.e. caller has to do it if/as necessary)

Overrides:
  `findSubtypes` in class `AnnotationIntrospector`
Parameters:
  `a` - Annotated entity (class, field/method) to check for annotations

#### findTypeName

    public String findTypeName(AnnotatedClass ac)

Description copied from class: `AnnotationIntrospector`
Method for checking if specified type has explicit name.

Overrides:
  `findTypeName` in class `AnnotationIntrospector`
Parameters:
  `ac` - Class to check for type name annotations

#### findReferenceType

    public AnnotationIntrospector.ReferenceProperty findReferenceType(AnnotatedMember member)

Description copied from class: `AnnotationIntrospector`
Method for checking if given member indicates that it is part of a reference (parent/child).

Overrides:
  `findReferenceType` in class `AnnotationIntrospector`

#### findUnwrappingNameTransformer

    public NameTransformer findUnwrappingNameTransformer(AnnotatedMember member)

Description copied from class: `AnnotationIntrospector`
Method called to check whether given property is marked to be "unwrapped" when being serialized (and appropriately handled in reverse direction, i.e. expect unwrapped representation during deserialization). Return value is the name transformation to use, if wrapping/unwrapping should be done, or null if not -- note that transformation may simply be identity transformation (no changes).

Overrides:
  `findUnwrappingNameTransformer` in class `AnnotationIntrospector`

#### findInjectableValue

    public JacksonInject.Value findInjectableValue(AnnotatedMember m)

Description copied from class: `AnnotationIntrospector`
Method called to find out whether given member expectes a value to be injected, and if so, what is the identifier of the value to use during injection. Type if identifier needs to be compatible with provider of values (of type `InjectableValues`); often a simple String id is used.

Overrides:
  `findInjectableValue` in class `AnnotationIntrospector`
Parameters:
  `m` - Member to check
Returns:
  Identifier of value to inject, if any; null if no injection indicator is found

#### hasIgnoreMarker

    public boolean hasIgnoreMarker(AnnotatedMember m)

Description copied from class: `AnnotationIntrospector`
Method called to check whether given property is marked to be ignored. This is used to determine whether to ignore properties, on per-property basis, usually combining annotations from multiple accessors (getters, setters, fields, constructor parameters).

Overrides:
  `hasIgnoreMarker` in class `AnnotationIntrospector`

#### hasRequiredMarker

    public Boolean hasRequiredMarker(AnnotatedMember m)

Description copied from class: `AnnotationIntrospector`
Method that can be called to check whether this member has an annotation that suggests whether value for matching property is required or not.

Overrides:
  `hasRequiredMarker` in class `AnnotationIntrospector`

#### findInjectableValueId

    @Deprecated
    public Object findInjectableValueId(AnnotatedMember m)

Deprecated.

Overrides:
  `findInjectableValueId` in class `AnnotationIntrospector`

#### findSerializer

    public Object findSerializer(Annotated am)

Description copied from class: `AnnotationIntrospector`
Method for getting a serializer definition on specified method or field. Type of definition is either instance (of type `JsonSerializer`) or Class (of type `Class<JsonSerializer>`; if value of different type is returned, a runtime exception may be thrown by caller.

Overrides:
  `findSerializer` in class `AnnotationIntrospector`

#### findKeySerializer

    public Object findKeySerializer(Annotated a)

Description copied from class: `AnnotationIntrospector`
Method for getting a serializer definition for keys of associated `Map` property. Type of definition is either instance (of type `JsonSerializer`) or Class (of type `Class<JsonSerializer>`); if value of different type is returned, a runtime exception may be thrown by caller.

Overrides:
  `findKeySerializer` in class `AnnotationIntrospector`

#### findContentSerializer

    public Object findContentSerializer(Annotated a)

Description copied from class: `AnnotationIntrospector`
Method for getting a serializer definition for content (values) of associated `Collection`, `array` or `Map` property. Type of definition is either instance (of type `JsonSerializer`) or Class (of type `Class<JsonSerializer>`); if value of different type is returned, a runtime exception may be thrown by caller.

Overrides:
  `findContentSerializer` in class `AnnotationIntrospector`

#### findNullSerializer

    public Object findNullSerializer(Annotated a)

Description copied from class: `AnnotationIntrospector`
Method for getting a serializer definition for serializer to use for nulls (null values) of associated property or type.

Overrides:
  `findNullSerializer` in class `AnnotationIntrospector`

#### findSerializationInclusion

    @Deprecated
    public JsonInclude.Include findSerializationInclusion(Annotated a,
                                                                      JsonInclude.Include defValue)

Deprecated.
Description copied from class: `AnnotationIntrospector`
Method for checking whether given annotated entity (class, method, field) defines which Bean/Map properties are to be included in serialization. If no annotation is found, method should return given second argument; otherwise value indicated by the annotation.

Note that meaning of inclusion value depends on whether it is for a Class or property (field/method/constructor): in former case, it is the default for all properties; in latter case it is specific override for annotated property.

Overrides:
  `findSerializationInclusion` in class `AnnotationIntrospector`
Returns:
  Enumerated value indicating which properties to include in serialization

#### findSerializationInclusionForContent

    @Deprecated
    public JsonInclude.Include findSerializationInclusionForContent(Annotated a,
                                                                                JsonInclude.Include defValue)

Deprecated.
Description copied from class: `AnnotationIntrospector`
Method for checking whether content (entries) of a `Map` property are to be included during serialization or not. NOTE: this is NOT called for POJO properties, or array/Collection elements.

Overrides:
  `findSerializationInclusionForContent` in class `AnnotationIntrospector`

#### findPropertyInclusion

    public JsonInclude.Value findPropertyInclusion(Annotated a)

Description copied from class: `AnnotationIntrospector`
Method for checking inclusion criteria for a type (Class) or property (yes, method name is bit unfortunate -- not just for properties!). In case of class, acts as the default for properties POJO contains; for properties acts as override for class defaults and possible global defaults.

Overrides:
  `findPropertyInclusion` in class `AnnotationIntrospector`

#### findSerializationTyping

    public JsonSerialize.Typing findSerializationTyping(Annotated a)

Description copied from class: `AnnotationIntrospector`
Method for accessing declared typing mode annotated (if any). This is used for type detection, unless more granular settings (such as actual exact type; or serializer to use which means no type information is needed) take precedence.

Overrides:
  `findSerializationTyping` in class `AnnotationIntrospector`
Returns:
  Typing mode to use, if annotation is found; null otherwise

#### findSerializationConverter

    public Object findSerializationConverter(Annotated a)

Description copied from class: `AnnotationIntrospector`
Method for finding `Converter` that annotated entity (property or class) has indicated to be used as part of serialization. If not null, either has to be actual `Converter` instance, or class for such converter; and resulting converter will be used first to convert property value to converter target type, and then serializer for that type is used for actual serialization.

This feature is typically used to convert internal values into types that Jackson can convert.

Note also that this feature does not necessarily work well with polymorphic type handling, or object identity handling; if such features are needed an explicit serializer is usually better way to handle serialization.

Overrides:
  `findSerializationConverter` in class `AnnotationIntrospector`
Parameters:
  `a` - Annotated property (field, method) or class to check for annotations

#### findSerializationContentConverter

    public Object findSerializationContentConverter(AnnotatedMember a)

Description copied from class: `AnnotationIntrospector`
Method for finding `Converter` that annotated property has indicated needs to be used for values of container type (this also means that method should only be called for properties of container types, List/Map/array properties).

If not null, either has to be actual `Converter` instance, or class for such converter; and resulting converter will be used first to convert property value to converter target type, and then serializer for that type is used for actual serialization.

Other notes are same as those for `AnnotationIntrospector.findSerializationConverter(com.fasterxml.jackson.databind.introspect.Annotated)`

Overrides:
  `findSerializationContentConverter` in class `AnnotationIntrospector`
Parameters:
  `a` - Annotated property (field, method) to check.

#### findViews

    public Class<?>[] findViews(Annotated a)

Description copied from class: `AnnotationIntrospector`
Method for checking if annotated property (represented by a field or getter/setter method) has definitions for views it is to be included in. If null is returned, no view definitions exist and property is always included (or always excluded as per default view inclusion configuration); otherwise it will only be included for views included in returned array. View matches are checked using class inheritance rules (sub-classes inherit inclusions of super-classes)

Since 2.9 this method may also be called to find "default view(s)" for `AnnotatedClass`

Overrides:
  `findViews` in class `AnnotationIntrospector`
Parameters:
  `a` - Annotated property (represented by a method, field or ctor parameter)
Returns:
  Array of views (represented by classes) that the property is included in; if null, always included (same as returning array containing `Object.class`)

#### isTypeId

    public Boolean isTypeId(AnnotatedMember member)

Description copied from class: `AnnotationIntrospector`
Method for checking whether given accessor claims to represent type id: if so, its value may be used as an override, instead of generated type id.

Overrides:
  `isTypeId` in class `AnnotationIntrospector`

#### findObjectIdInfo

    public ObjectIdInfo findObjectIdInfo(Annotated ann)

Description copied from class: `AnnotationIntrospector`
Method for checking whether given annotated thing (type, or accessor) indicates that values referenced (values of type of annotated class, or values referenced by annotated property; latter having precedence) should include Object Identifier, and if so, specify details of Object Identity used.

Overrides:
  `findObjectIdInfo` in class `AnnotationIntrospector`

#### findObjectReferenceInfo

    public ObjectIdInfo findObjectReferenceInfo(Annotated ann,
                                                ObjectIdInfo objectIdInfo)

Description copied from class: `AnnotationIntrospector`
Method for figuring out additional properties of an Object Identity reference

Overrides:
  `findObjectReferenceInfo` in class `AnnotationIntrospector`

#### findFormat

    public JsonFormat.Value findFormat(Annotated ann)

Description copied from class: `AnnotationIntrospector`
Method for finding format annotations for property or class. Return value is typically used by serializers and/or deserializers to customize presentation aspects of the serialized value.

Overrides:
  `findFormat` in class `AnnotationIntrospector`

#### findWrapperName

    public PropertyName findWrapperName(Annotated ann)

Description copied from class: `AnnotationIntrospector`
Method used to check if specified property has annotation that indicates that it should be wrapped in an element; and if so, name to use. Note that not all serializers and deserializers support use this method: currently (2.1) it is only used by XML-backed handlers.

Overrides:
  `findWrapperName` in class `AnnotationIntrospector`
Returns:
  Wrapper name to use, if any, or `PropertyName.USE_DEFAULT` to indicate that no wrapper element should be used.

#### findPropertyDefaultValue

    public String findPropertyDefaultValue(Annotated ann)

Description copied from class: `AnnotationIntrospector`
Method for finding suggested default value (as simple textual serialization) for the property. While core databind does not make any use of it, it is exposed for extension modules to use: an expected use is generation of schema representations and documentation.

Overrides:
  `findPropertyDefaultValue` in class `AnnotationIntrospector`

#### findPropertyDescription

    public String findPropertyDescription(Annotated ann)

Description copied from class: `AnnotationIntrospector`
Method used to check whether specified property member (accessor or mutator) defines human-readable description to use for documentation. There are no further definitions for contents; for example, whether these may be marked up using HTML is not defined.

Overrides:
  `findPropertyDescription` in class `AnnotationIntrospector`
Returns:
  Human-readable description, if any.

#### findPropertyIndex

    public Integer findPropertyIndex(Annotated ann)

Description copied from class: `AnnotationIntrospector`
Method used to check whether specified property member (accessor or mutator) defines numeric index, and if so, what is the index value. Possible use cases for index values included use by underlying data format (some binary formats mandate use of index instead of name) and ordering of properties (for documentation, or during serialization).

Overrides:
  `findPropertyIndex` in class `AnnotationIntrospector`
Returns:
  Explicitly specified index for the property, if any

#### findImplicitPropertyName

    public String findImplicitPropertyName(AnnotatedMember ann)

Description copied from class: `AnnotationIntrospector`
Method for finding implicit name for a property that given annotated member (field, method, creator parameter) may represent. This is different from explicit, annotation-based property name, in that it is "weak" and does not either proof that a property exists (for example, if visibility is not high enough), or override explicit names. In practice this method is used to introspect optional names for creator parameters (which may or may not be available and cannot be detected by standard databind); or to provide alternate name mangling for fields, getters and/or setters.

Overrides:
  `findImplicitPropertyName` in class `AnnotationIntrospector`

#### findPropertyAliases

    public List<PropertyName> findPropertyAliases(Annotated ann)

Description copied from class: `AnnotationIntrospector`
Method called to find if given property has alias(es) defined.

Overrides:
  `findPropertyAliases` in class `AnnotationIntrospector`
Returns:
  `null` if member has no information; otherwise a `List` (possibly empty) of aliases to use.

#### findPropertyAccess

    public JsonProperty.Access findPropertyAccess(Annotated ann)

Description copied from class: `AnnotationIntrospector`
Method for finding optional access definition for a property, annotated on one of its accessors. If a definition for read-only, write-only or read-write cases, visibility rules may be modified. Note, however, that even more specific annotations (like one for ignoring specific accessor) may further override behavior of the access definition.

Overrides:
  `findPropertyAccess` in class `AnnotationIntrospector`

#### resolveSetterConflict

    public AnnotatedMethod resolveSetterConflict(MapperConfig<?> config,
                                                 AnnotatedMethod setter1,
                                                 AnnotatedMethod setter2)

Description copied from class: `AnnotationIntrospector`
Method called in cases where a class has two methods eligible to be used for the same logical property, and default logic is not enough to figure out clear precedence. Introspector may try to choose one to use; or, if unable, return `null` to indicate it cannot resolve the problem.

Overrides:
  `resolveSetterConflict` in class `AnnotationIntrospector`

#### refineSerializationType

    public JavaType refineSerializationType(MapperConfig<?> config,
                                            Annotated a,
                                            JavaType baseType)
                                     throws JsonMappingException

Description copied from class: `AnnotationIntrospector`
Method called to find out possible type refinements to use for deserialization, including not just value itself but key and/or content type, if type has those.

Overrides:
  `refineSerializationType` in class `AnnotationIntrospector`
Throws:
  `JsonMappingException`

#### findSerializationType

    @Deprecated
    public Class<?> findSerializationType(Annotated a)

Deprecated.

Overrides:
  `findSerializationType` in class `AnnotationIntrospector`

#### findSerializationKeyType

    @Deprecated
    public Class<?> findSerializationKeyType(Annotated am,
                                                         JavaType baseType)

Deprecated.

Overrides:
  `findSerializationKeyType` in class `AnnotationIntrospector`

#### findSerializationContentType

    @Deprecated
    public Class<?> findSerializationContentType(Annotated am,
                                                             JavaType baseType)

Deprecated.

Overrides:
  `findSerializationContentType` in class `AnnotationIntrospector`

#### findSerializationPropertyOrder

    public String[] findSerializationPropertyOrder(AnnotatedClass ac)

Description copied from class: `AnnotationIntrospector`
Method for accessing defined property serialization order (which may be partial). May return null if no ordering is defined.

Overrides:
  `findSerializationPropertyOrder` in class `AnnotationIntrospector`

#### findSerializationSortAlphabetically

    public Boolean findSerializationSortAlphabetically(Annotated ann)

Description copied from class: `AnnotationIntrospector`
Method for checking whether an annotation indicates that serialized properties for which no explicit is defined should be alphabetically (lexicograpically) ordered

Overrides:
  `findSerializationSortAlphabetically` in class `AnnotationIntrospector`

#### findAndAddVirtualProperties

    public void findAndAddVirtualProperties(MapperConfig<?> config,
                                            AnnotatedClass ac,
                                            List<BeanPropertyWriter> properties)

Description copied from class: `AnnotationIntrospector`
Method for adding possible virtual properties to be serialized along with regular properties.

Overrides:
  `findAndAddVirtualProperties` in class `AnnotationIntrospector`

#### findNameForSerialization

    public PropertyName findNameForSerialization(Annotated a)

Description copied from class: `AnnotationIntrospector`
Method for checking whether given property accessors (method, field) has an annotation that suggests property name to use for serialization. Should return null if no annotation is found; otherwise a non-null name (possibly `PropertyName.USE_DEFAULT`, which means "use default heuristics").

Overrides:
  `findNameForSerialization` in class `AnnotationIntrospector`
Parameters:
  `a` - Property accessor to check
Returns:
  Name to use if found; null if not.

#### hasAsValue

    public Boolean hasAsValue(Annotated a)

Description copied from class: `AnnotationIntrospector`
Method for checking whether given method has an annotation that suggests that the return value of annotated method should be used as "the value" of the object instance; usually serialized as a primitive value such as String or number.

Overrides:
  `hasAsValue` in class `AnnotationIntrospector`
Returns:
  `Boolean.TRUE` if such annotation is found and is not disabled; `Boolean.FALSE` if disabled annotation (block) is found (to indicate accessor is definitely NOT to be used "as value"); or `null` if no information found.

#### hasAnyGetter

    public Boolean hasAnyGetter(Annotated a)

Description copied from class: `AnnotationIntrospector`
Method for checking whether given method has an annotation that suggests that the method is to serve as "any setter"; method to be used for accessing set of miscellaneous "extra" properties, often bound with matching "any setter" method.

Overrides:
  `hasAnyGetter` in class `AnnotationIntrospector`
Returns:
  True if such annotation is found (and is not disabled), false otherwise

#### findEnumValues

    public String[] findEnumValues(Class<?> enumType,
                                   Enum<?>[] enumValues,
                                   String[] names)

Description copied from class: `AnnotationIntrospector`
Method for efficiently figuring out which if given set of `Enum` values have explicitly defined name. Method will overwrite entries in incoming `names` array with explicit names found, if any, leaving other entries unmodified.

Default implementation will simply delegate to `AnnotationIntrospector.findEnumValue(java.lang.Enum<?>)`, which is close enough, although unfortunately NOT 100% equivalent (as it will also consider `name()` to give explicit value).

Overrides:
  `findEnumValues` in class `AnnotationIntrospector`

#### findDefaultEnumValue

    public Enum<?> findDefaultEnumValue(Class<Enum<?>> enumCls)

Description copied from class: `AnnotationIntrospector`
Finds the Enum value that should be considered the default value, if possible.

Overrides:
  `findDefaultEnumValue` in class `AnnotationIntrospector`
Parameters:
  `enumCls` - The Enum class to scan for the default value.
Returns:
  null if none found or it's not possible to determine one.

#### findEnumValue

    @Deprecated
    public String findEnumValue(Enum<?> value)

Deprecated.
Description copied from class: `AnnotationIntrospector`
Method for determining the String value to use for serializing given enumeration entry; used when serializing enumerations as Strings (the standard method).

Overrides:
  `findEnumValue` in class `AnnotationIntrospector`
Returns:
  Serialized enum value.

#### hasAsValueAnnotation

    @Deprecated
    public boolean hasAsValueAnnotation(AnnotatedMethod am)

Deprecated.

Overrides:
  `hasAsValueAnnotation` in class `AnnotationIntrospector`

#### hasAnyGetterAnnotation

    @Deprecated
    public boolean hasAnyGetterAnnotation(AnnotatedMethod am)

Deprecated.

Overrides:
  `hasAnyGetterAnnotation` in class `AnnotationIntrospector`

#### findDeserializer

    public Object findDeserializer(Annotated a)

Description copied from class: `AnnotationIntrospector`
Method for getting a deserializer definition on specified method or field. Type of definition is either instance (of type `JsonDeserializer`) or Class (of type `Class<JsonDeserializer>`): if value of different type is returned, a runtime exception may be thrown by caller.

Overrides:
  `findDeserializer` in class `AnnotationIntrospector`

#### findKeyDeserializer

    public Object findKeyDeserializer(Annotated a)

Description copied from class: `AnnotationIntrospector`
Method for getting a deserializer definition for keys of associated `Map` property. Type of definition is either instance (of type `JsonDeserializer`) or Class (of type `Class<JsonDeserializer>`): if value of different type is returned, a runtime exception may be thrown by caller.

Overrides:
  `findKeyDeserializer` in class `AnnotationIntrospector`

#### findContentDeserializer

    public Object findContentDeserializer(Annotated am)

Description copied from class: `AnnotationIntrospector`
Method for getting a deserializer definition for content (values) of associated `Collection`, `array` or `Map` property. Type of definition is either instance (of type `JsonDeserializer`) or Class (of type `Class<JsonDeserializer>`): if value of different type is returned, a runtime exception may be thrown by caller.

Overrides:
  `findContentDeserializer` in class `AnnotationIntrospector`

#### findDeserializationConverter

    public Object findDeserializationConverter(Annotated a)

Description copied from class: `AnnotationIntrospector`
Method for finding `Converter` that annotated entity (property or class) has indicated to be used as part of deserialization. If not null, either has to be actual `Converter` instance, or class for such converter; and resulting converter will be used after Jackson has deserializer data into intermediate type (Converter input type), and Converter needs to convert this into its target type to be set as property value.

This feature is typically used to convert intermediate Jackson types (that default deserializers can produce) into custom type instances.

Note also that this feature does not necessarily work well with polymorphic type handling, or object identity handling; if such features are needed an explicit deserializer is usually better way to handle deserialization.

Overrides:
  `findDeserializationConverter` in class `AnnotationIntrospector`
Parameters:
  `a` - Annotated property (field, method) or class to check for annotations

#### findDeserializationContentConverter

    public Object findDeserializationContentConverter(AnnotatedMember a)

Description copied from class: `AnnotationIntrospector`
Method for finding `Converter` that annotated property has indicated needs to be used for values of container type (this also means that method should only be called for properties of container types, List/Map/array properties).

If not null, either has to be actual `Converter` instance, or class for such converter; and resulting converter will be used after Jackson has deserializer data into intermediate type (Converter input type), and Converter needs to convert this into its target type to be set as property value.

Other notes are same as those for `AnnotationIntrospector.findDeserializationConverter(com.fasterxml.jackson.databind.introspect.Annotated)`

Overrides:
  `findDeserializationContentConverter` in class `AnnotationIntrospector`
Parameters:
  `a` - Annotated property (field, method) to check.

#### refineDeserializationType

    public JavaType refineDeserializationType(MapperConfig<?> config,
                                              Annotated a,
                                              JavaType baseType)
                                       throws JsonMappingException

Description copied from class: `AnnotationIntrospector`
Method called to find out possible type refinements to use for deserialization.

Overrides:
  `refineDeserializationType` in class `AnnotationIntrospector`
Throws:
  `JsonMappingException`

#### findDeserializationType

    @Deprecated
    public Class<?> findDeserializationType(Annotated am,
                                                        JavaType baseType)

Deprecated.
Description copied from class: `AnnotationIntrospector`
Method for accessing annotated type definition that a property can have, to be used as the type for deserialization instead of the static (declared) type. Type is usually narrowing conversion (i.e.subtype of declared type). Declared return type of the method is also considered acceptable.

Overrides:
  `findDeserializationType` in class `AnnotationIntrospector`
  `baseType` - Assumed type before considering annotations
Returns:
  Class to use for deserialization instead of declared type

#### findDeserializationKeyType

    @Deprecated
    public Class<?> findDeserializationKeyType(Annotated am,
                                                           JavaType baseKeyType)

Deprecated.
Description copied from class: `AnnotationIntrospector`
Method for accessing additional narrowing type definition that a method can have, to define more specific key type to use. It should be only be used with `Map` types.

Overrides:
  `findDeserializationKeyType` in class `AnnotationIntrospector`
  `baseKeyType` - Assumed key type before considering annotations
Returns:
  Class specifying more specific type to use instead of declared type, if annotation found; null if not

#### findDeserializationContentType

    @Deprecated
    public Class<?> findDeserializationContentType(Annotated am,
                                                               JavaType baseContentType)

Deprecated.
Description copied from class: `AnnotationIntrospector`
Method for accessing additional narrowing type definition that a method can have, to define more specific content type to use; content refers to Map values and Collection/array elements. It should be only be used with Map, Collection and array types.

Overrides:
  `findDeserializationContentType` in class `AnnotationIntrospector`
  `baseContentType` - Assumed content (value) type before considering annotations
Returns:
  Class specifying more specific type to use instead of declared type, if annotation found; null if not

#### findValueInstantiator

    public Object findValueInstantiator(AnnotatedClass ac)

Description copied from class: `AnnotationIntrospector`
Method getting `ValueInstantiator` to use for given type (class): return value can either be an instance of instantiator, or class of instantiator to create.

Overrides:
  `findValueInstantiator` in class `AnnotationIntrospector`

#### findPOJOBuilder

    public Class<?> findPOJOBuilder(AnnotatedClass ac)

Description copied from class: `AnnotationIntrospector`
Method for finding Builder object to use for constructing value instance and binding data (sort of combining value instantiators that can construct, and deserializers that can bind data).

Note that unlike accessors for some helper Objects, this method does not allow returning instances: the reason is that builders have state, and a separate instance needs to be created for each deserialization call.

Overrides:
  `findPOJOBuilder` in class `AnnotationIntrospector`

#### findPOJOBuilderConfig

    public JsonPOJOBuilder.Value findPOJOBuilderConfig(AnnotatedClass ac)

Overrides:
  `findPOJOBuilderConfig` in class `AnnotationIntrospector`

#### findNameForDeserialization

    public PropertyName findNameForDeserialization(Annotated a)

Description copied from class: `AnnotationIntrospector`
Method for checking whether given property accessors (method, field) has an annotation that suggests property name to use for deserialization (reading JSON into POJOs). Should return null if no annotation is found; otherwise a non-null name (possibly `PropertyName.USE_DEFAULT`, which means "use default heuristics").

Overrides:
  `findNameForDeserialization` in class `AnnotationIntrospector`
Parameters:
  `a` - Property accessor to check
Returns:
  Name to use if found; null if not.

#### hasAnySetter

    public Boolean hasAnySetter(Annotated a)

Description copied from class: `AnnotationIntrospector`
Method for checking whether given method has an annotation that suggests that the method is to serve as "any setter"; method to be used for setting values of any properties for which no dedicated setter method is found.

Overrides:
  `hasAnySetter` in class `AnnotationIntrospector`
Returns:
  True if such annotation is found (and is not disabled), false otherwise

#### findSetterInfo

    public JsonSetter.Value findSetterInfo(Annotated a)

Description copied from class: `AnnotationIntrospector`
Method for finding possible settings for property, given annotations on an accessor.

Overrides:
  `findSetterInfo` in class `AnnotationIntrospector`

#### findMergeInfo

    public Boolean findMergeInfo(Annotated a)

Description copied from class: `AnnotationIntrospector`
Method for finding merge settings for property, if any.

Overrides:
  `findMergeInfo` in class `AnnotationIntrospector`

#### hasCreatorAnnotation

    @Deprecated
    public boolean hasCreatorAnnotation(Annotated a)

Deprecated.
Description copied from class: `AnnotationIntrospector`
Method for checking whether given annotated item (method, constructor) has an annotation that suggests that the method is a "creator" (aka factory) method to be used for construct new instances of deserialized values.

Overrides:
  `hasCreatorAnnotation` in class `AnnotationIntrospector`
Returns:
  True if such annotation is found (and is not disabled), false otherwise

#### findCreatorBinding

    @Deprecated
    public JsonCreator.Mode findCreatorBinding(Annotated a)

Deprecated.
Description copied from class: `AnnotationIntrospector`
Method for finding indication of creator binding mode for a creator (something for which `AnnotationIntrospector.hasCreatorAnnotation(com.fasterxml.jackson.databind.introspect.Annotated)` returns true), for cases where there may be ambiguity (currently: single-argument creator with implicit but no explicit name for the argument).

Overrides:
  `findCreatorBinding` in class `AnnotationIntrospector`

#### findCreatorAnnotation

    public JsonCreator.Mode findCreatorAnnotation(MapperConfig<?> config,
                                                  Annotated a)

Description copied from class: `AnnotationIntrospector`
Method called to check whether potential Creator (constructor or static factory method) has explicit annotation to indicate it as actual Creator; and if so, which `JsonCreator.Mode` to use.

NOTE: caller needs to consider possibility of both `null` (no annotation found) and `JsonCreator.Mode.DISABLED` (annotation found, but disabled); latter is necessary as marker in case multiple introspectors are chained, as well as possibly as when using mix-in annotations.

Overrides:
  `findCreatorAnnotation` in class `AnnotationIntrospector`
Parameters:
  `config` - Configuration settings in effect (for serialization or deserialization)
  `a` - Annotated accessor (usually constructor or static method) to check

#### hasAnySetterAnnotation

    @Deprecated
    public boolean hasAnySetterAnnotation(AnnotatedMethod am)

Deprecated.

Overrides:
  `hasAnySetterAnnotation` in class `AnnotationIntrospector`

#### _isExplicitClassOrOb

    protected boolean _isExplicitClassOrOb(Object maybeCls,
                                           Class<?> implicit)

#### _explicitClassOrOb

    protected Object _explicitClassOrOb(Object maybeCls,
                                        Class<?> implicit)